const EventEmitter = require('events');
const util = require('util');
var request = require('request');

function JsonDataSource(url, refreshRate) {
  this.url = url;
  this.data = {};
  this.dataSetOnce = false;
  this.refreshRate = refreshRate || 2000;

  this.getData = function() {
    request(this.url, (err, res, data) => {
      if (!err && res.statusCode == 200) {
        this.emit('dataReceive', JSON.parse(data));
      }
    });
  }

  this.on('dataReceive', (data) => {
    this.data = data;
    setTimeout(() => { this.getData(); }, this.refreshRate);
    this.emit('dataSet');
    if (!this.dataSetOnce) this.dataSetOnce = true;
  });

  this.getData();
}

util.inherits(JsonDataSource, EventEmitter);

module.exports = JsonDataSource;
